unit FrmDayIODlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Day;

type
  TFrmDayIODialog = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    EditStr: TEdit;
    EditDate: TEdit;
    procedure OKBtnClick(Sender: TObject);
  private
     m_TDay: TDay;

     function Init(aDay: TDay): Boolean;

     function  GetData: Boolean;

     function  GetDate(aEdit:TEdit): Boolean;
  public
     function Execute(aDay: TDay): Boolean;
  
  end;
{**************************************************************************************************}
var
  FrmDayIODialog: TFrmDayIODialog;
{**************************************************************************************************}
implementation
uses Dialogs;

{$R *.DFM}
{**************************************************************************************************}
{* Eigene Funktionen                                                                              *}
{**************************************************************************************************}
function  TFrmDayIODialog.Execute(aDay: TDay): Boolean;
begin
   Result := FALSE;
   if(Init(aDay)) then
      Result := (ShowModal = mrOk);
end;
{**************************************************************************************************}
function  TFrmDayIODialog.Init(aDay:TDay): Boolean;
begin
   try
      Result := Assigned(aDay);
      if(Result) then begin
         m_TDay := aDay;

         EditDate.Text := DateToStr(m_TDay.Day);
         EditStr.Text  := m_TDay.DisplayString;
      end;
   except
      on E:Exception do begin
         Result := FALSE;
         MessageDlg('Error while initilazing dialog.'+#13+#10+E.Message, mtError, [mbOk] ,0);
      end;
   end;
end;
{**************************************************************************************************}
function  TFrmDayIODialog.GetData: Boolean;
begin
   try
      Result := GetDate(EditDate);
      if(Not Result) then
         Raise Exception.Create('Error: Date is blank or invalid');

      m_TDay.Day          := StrToDate(EditDate.Text);
      m_TDay.DisplayString:= EditStr.Text;

   except
      on E:Exception do begin
         Result := FALSE;
         MessageDlg('Error while reading fields.'+#13+#10+E.Message, mtError, [mbOk] ,0);
      end;
   end;
end;
{**************************************************************************************************}
function  TFrmDayIODialog.GetDate(aEdit:TEdit): Boolean;
begin
   try
      StrToDate(aEdit.Text);
      Result := TRUE;
   except
      Result := FALSE;
   end;
end;
{**************************************************************************************************}
{**************************************************************************************************}
{* Eigene Funktionen (ENDE)                                                                       *}
{**************************************************************************************************}
procedure TFrmDayIODialog.OKBtnClick(Sender: TObject);
begin
   ModalResult := mrNone;
   if(GetData) then
      ModalResult := mrOk;
end;
{**************************************************************************************************}
end.
